# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 1.5.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from inspect import getfullargspec
from typing import Any
from typing import List
from typing import Optional
from typing import TYPE_CHECKING
from typing import Union

from pydantic import BaseModel
from pydantic import Field
from pydantic import StrictStr
from pydantic import ValidationError
from pydantic import validator

from superwise_api.client.models.tool_config_big_query import ToolConfigBigQuery
from superwise_api.client.models.tool_config_pg_vector import ToolConfigPGVector
from superwise_api.client.models.tool_config_sql_database_mssql import ToolConfigSQLDatabaseMSSQL
from superwise_api.client.models.tool_config_sql_database_my_sql import ToolConfigSQLDatabaseMySQL
from superwise_api.client.models.tool_config_sql_database_oracle import ToolConfigSQLDatabaseOracle
from superwise_api.client.models.tool_config_sql_database_postgres import ToolConfigSQLDatabasePostgres

TOOL_CONFIG_ANY_OF_SCHEMAS = [
    "ToolConfigBigQuery",
    "ToolConfigPGVector",
    "ToolConfigSQLDatabaseMSSQL",
    "ToolConfigSQLDatabaseMySQL",
    "ToolConfigSQLDatabaseOracle",
    "ToolConfigSQLDatabasePostgres",
    "object",
]


class ToolConfig(BaseModel):
    """
    ToolConfig
    """

    # data type: ToolConfigSQLDatabasePostgres
    anyof_schema_1_validator: Optional[ToolConfigSQLDatabasePostgres] = None
    # data type: ToolConfigSQLDatabaseMySQL
    anyof_schema_2_validator: Optional[ToolConfigSQLDatabaseMySQL] = None
    # data type: ToolConfigSQLDatabaseMSSQL
    anyof_schema_4_validator: Optional[ToolConfigSQLDatabaseMSSQL] = None
    # data type: ToolConfigSQLDatabaseOracle
    anyof_schema_5_validator: Optional[ToolConfigSQLDatabaseOracle] = None
    # data type: ToolConfigBigQuery
    anyof_schema_6_validator: Optional[ToolConfigBigQuery] = None
    # data type: ToolConfigPGVector
    anyof_schema_7_validator: Optional[ToolConfigPGVector] = None
    # data type: object
    anyof_schema_8_validator: Optional[Any] = None
    if TYPE_CHECKING:
        actual_instance: Union[
            ToolConfigBigQuery,
            ToolConfigPGVector,
            ToolConfigSQLDatabaseMSSQL,
            ToolConfigSQLDatabaseMySQL,
            ToolConfigSQLDatabaseOracle,
            ToolConfigSQLDatabasePostgres,
            object,
        ]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(TOOL_CONFIG_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator("actual_instance")
    def actual_instance_must_validate_anyof(cls, v):
        instance = ToolConfig.construct()
        error_messages = []
        # validate data type: ToolConfigSQLDatabasePostgres
        if not isinstance(v, ToolConfigSQLDatabasePostgres):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ToolConfigSQLDatabasePostgres`")
        else:
            return v

        # validate data type: ToolConfigSQLDatabaseMySQL
        if not isinstance(v, ToolConfigSQLDatabaseMySQL):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ToolConfigSQLDatabaseMySQL`")
        else:
            return v

        # validate data type: ToolConfigSQLDatabaseMSSQL
        if not isinstance(v, ToolConfigSQLDatabaseMSSQL):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ToolConfigSQLDatabaseMSSQL`")
        else:
            return v

        # validate data type: ToolConfigSQLDatabaseOracle
        if not isinstance(v, ToolConfigSQLDatabaseOracle):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ToolConfigSQLDatabaseOracle`")
        else:
            return v

        # validate data type: ToolConfigBigQuery
        if not isinstance(v, ToolConfigBigQuery):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ToolConfigBigQuery`")
        else:
            return v

        # validate data type: ToolConfigPGVector
        if not isinstance(v, ToolConfigPGVector):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ToolConfigPGVector`")
        else:
            return v

        # validate data type: object
        try:
            instance.anyof_schema_8_validator = v
            return v
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        if error_messages:
            # no match
            raise ValueError(
                "No match found when setting the actual_instance in ToolConfig with anyOf schemas: ToolConfigBigQuery, ToolConfigPGVector, ToolConfigSQLDatabaseMSSQL, ToolConfigSQLDatabaseMySQL, ToolConfigSQLDatabaseOracle, ToolConfigSQLDatabasePostgres, object. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> ToolConfig:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> ToolConfig:
        """Returns the object represented by the json string"""
        instance = ToolConfig.construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[ToolConfigSQLDatabasePostgres] = None
        try:
            instance.actual_instance = ToolConfigSQLDatabasePostgres.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[ToolConfigSQLDatabaseMySQL] = None
        try:
            instance.actual_instance = ToolConfigSQLDatabaseMySQL.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[ToolConfigSQLDatabaseMSSQL] = None
        try:
            instance.actual_instance = ToolConfigSQLDatabaseMSSQL.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_5_validator: Optional[ToolConfigSQLDatabaseOracle] = None
        try:
            instance.actual_instance = ToolConfigSQLDatabaseOracle.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_6_validator: Optional[ToolConfigBigQuery] = None
        try:
            instance.actual_instance = ToolConfigBigQuery.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_7_validator: Optional[ToolConfigPGVector] = None
        try:
            instance.actual_instance = ToolConfigPGVector.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into object
        try:
            # validation
            instance.anyof_schema_8_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.anyof_schema_8_validator
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into ToolConfig with anyOf schemas: ToolConfigBigQuery, ToolConfigPGVector, ToolConfigSQLDatabaseMSSQL, ToolConfigSQLDatabaseMySQL, ToolConfigSQLDatabaseOracle, ToolConfigSQLDatabasePostgres, object. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            return json.dumps(self.actual_instance)

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())
