# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 1.6.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any
from typing import Optional

from pydantic import BaseModel
from pydantic import constr
from pydantic import Field
from pydantic import validator


class ToolConfigSQLDatabaseMSSQL(BaseModel):
    """
    ToolConfigSQLDatabaseMSSQL
    """

    type: Optional[Any] = Field(...)
    connection_string: constr(strict=True) = Field(...)
    __properties = ["type", "connection_string"]

    @validator("connection_string")
    def connection_string_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^mssql:\/\/", value):
            raise ValueError(r"must validate the regular expression /^mssql:\/\//")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ToolConfigSQLDatabaseMSSQL:
        """Create an instance of ToolConfigSQLDatabaseMSSQL from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # set to None if type (nullable) is None
        # and __fields_set__ contains the field
        if self.type is None and "type" in self.__fields_set__:
            _dict["type"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ToolConfigSQLDatabaseMSSQL:
        """Create an instance of ToolConfigSQLDatabaseMSSQL from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ToolConfigSQLDatabaseMSSQL.parse_obj(obj)

        _obj = ToolConfigSQLDatabaseMSSQL.parse_obj(
            {"type": obj.get("type"), "connection_string": obj.get("connection_string")}
        )
        return _obj
